poj 3126 Prime Path BFS

Prime Path
Time Limit: 1000MS Memory Limit: 65536K
Total Submissions: 6010 Accepted: 3440

Description

poj 3126 Prime Path BFSThe ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3

1033 8179

1373 8017

1033 1033

Sample Output

6

7

0
题意:给两个质数,分别为起点终点。每次可以变动一位为下一个质数,问最少经过多少次变动才能得到终点的质数。
思路:最简单的BFS。
#include<cstdio>

#include<cmath>

#include<cstring>

#include<queue>

using namespace std;

short time[9999];

bool is_prime(int x)

{

	if(x%2==0) return false;

	for(int i=3;i<=(int)(sqrt((double)x)+0.5);i+=2)

	{

		if(x%i==0) return false;

	}

	return true;

}

short bfs(int start,int end)

{

	if(start==end) return 0;

	int now,tmp,a,b,c,d;

	memset(time,-1,sizeof(time));

	time[start]=0;

	queue<short> que;

	que.push(start);

	while(!que.empty())

	{

		now=que.front();que.pop();

		d=now;

		a=d%10;d/=10;

		b=d%10;d/=10;

		c=d%10;d/=10;

		for(int i=1;i<=9;i++)

		{

			tmp=i*1000+c*100+b*10+a;

			if(tmp==end) return time[now]+1;

			if( time[tmp]==-1 && is_prime(tmp) )

			{

				que.push(tmp);

				time[tmp]=time[now]+1;

			}

		}

		for(int i=0;i<=9;i++)

		{

			tmp=d*1000+i*100+b*10+a;

			if(tmp==end) return time[now]+1;

			if( time[tmp]==-1 && is_prime(tmp) )

			{

				que.push(tmp);

				time[tmp]=time[now]+1;

			}

			tmp=d*1000+c*100+i*10+a;

			if(tmp==end) return time[now]+1;

			if( time[tmp]==-1 && is_prime(tmp) )

			{

				que.push(tmp);

				time[tmp]=time[now]+1;

			}

			tmp=d*1000+c*100+b*10+i;

			if(tmp==end) return time[now]+1;

			if( time[tmp]==-1 && is_prime(tmp) )

			{

				que.push(tmp);

				time[tmp]=time[now]+1;

			}

		}

	}

}

int main()

{

	int T;scanf("%d",&T);

	int start,end;

	while(T--)

	{

		scanf("%d%d",&start,&end);

		printf("%d\n",bfs(start,end));

	}

	return 0;

}

  

你可能感兴趣的:(Path)